unit UPseudoCalculatedFields;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, UExcelAdapter, XLSAdapter, UCustomFlexCelReport,
  UFlexCelReport, DB, DBTables, ShellAPI;

type
  TForm1 = class(TForm)
    Report: TFlexCelReport;
    XLSAdapter1: TXLSAdapter;
    btnRun: TButton;
    Text: TMemo;
    Employee: TTable;
    DsEmployee: TDataSource;
    OpenDialog: TOpenDialog;
    Orders: TQuery;
    procedure btnRunClick(Sender: TObject);
  private
    function GetEmployeeHash: variant;
    { Private declarations }
  public
    { Public declarations }
  published
  //Field definitions to use on the template.
  property EmployeeHash: variant read GetEmployeeHash;
  //FUNCTIONS SHOULD ***ALWAYS*** be defined as function xxx(const PAramters: array of variant): variant
  function OrderHash(const Parameters: array of variant): variant;
  function Upper(const Parameters: array of variant): variant;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnRunClick(Sender: TObject);
begin
  if not OpenDialog.Execute then exit;
  Report.FileName := OpenDialog.FileName;
  //Note that XlsAdapter is set to AllowOverwritingFiles, no need to call DeleteFile.
  Report.Run;

  //Offer to open the file
  if MessageDlg('Do you want to open the generated file?', mtConfirmation, mbOKCancel, 0) = mrOk then
    ShellExecute(0,'open', PCHAR(Report.FileName), NIL,NIL, SW_SHOW);

end;

function TForm1.GetEmployeeHash: variant;
var
  EmployeeName: string;
  i: integer;
  Total: integer;
begin
  //Here we can calculate a field using the values of the dataset.
  //We will calculate a non sense hash, but you could do whatever here.
  EmployeeName := Employee['LastName'];
  Total := 0;
  for i:= 1 to Length(EmployeeName) do inc(Total, Ord(EmployeeName[i]));
  Result := Total;
end;

function TForm1.OrderHash(const Parameters: array of variant): variant;
var
  Decimals: integer;
begin
  //Again, in this example this makes no sense. But you can do whatever here.

  //Parse the parameters.
  if Length(Parameters) < 1 then Decimals:= 5 else Decimals:= Parameters[0];

  //Process the result.
  Result := IntToHex(Orders['OrderNo'], Decimals);
end;

function TForm1.Upper(const Parameters: array of variant): variant;
var
  Ds: TComponent;
begin
  if Length(Parameters) < 2 then Raise Exception.Create('Error, Upper needs 2 parameters');

  Ds:=FindComponent(Parameters[0]);
  if (Ds=nil) or not (Ds is TDataSet) then raise Exception.Create('Error, Dataset not found: ' + Parameters[0]);
  Result:= UpperCase((Ds as TDataSet)[Parameters[1]]);
end;

end.
